#include "StdAfx.h"
#include "C8ImageFrameDrawScriptletPlugin.h"
#include "XMLUtil.h"
#include "8ImageFrameDraw.h"
#include "ScriptletConstant.h"

REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SCRIPTLET_8IMAGEFRAMEDRAW_NODE, C8ImageFrameDrawScriptletPlugin);
C8ImageFrameDrawScriptletPlugin::C8ImageFrameDrawScriptletPlugin(void)
{
}

C8ImageFrameDrawScriptletPlugin::~C8ImageFrameDrawScriptletPlugin(void)
{
}
CComponent* C8ImageFrameDrawScriptletPlugin::_CreateComponent(TiXmlElement* pNode)
{
	CComponent* pComponent = new C8ImageFrameDraw;
	return pComponent;
}

BOOL C8ImageFrameDrawScriptletPlugin::ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode)
{
	BOOL bSuccess = __super::ModifyComponent(pParent, pTarget, pNode);
	if (bSuccess)
	{
		C8ImageFrameDraw* p8ImageFrame = reinterpret_cast<C8ImageFrameDraw*>(pTarget);
		if (p8ImageFrame == NULL)
		{
			return bSuccess;
		}
		TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};
		long lValue = 0;

		USES_CONVERSION;
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_BACKGROUND_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_BACKGROUND_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			COLORREF clrBack = XMLUtil::ColorFromString(szValue);
			p8ImageFrame->SetBackground(clrBack);
		}
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_LEFTTOP_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_LEFTTOP_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			IImage* pImage = LoadImage(szValue);
			if (pImage)
			{
				p8ImageFrame->SetLeftTopImage(pImage);
			}				
		}
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_CENTERTOP_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_CENTERTOP_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			IImage* pImage = LoadImage(szValue);
			if (pImage)
			{
				p8ImageFrame->SetCenterTopImage(pImage);
			}				
		}
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_RIGHTTOP_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_RIGHTTOP_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			IImage* pImage = LoadImage(szValue);
			if (pImage)
			{
				p8ImageFrame->SetRightTopImage(pImage);
			}				
		}
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_LEFTVCENTER_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_LEFTVCENTER_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			IImage* pImage = LoadImage(szValue);
			if (pImage)
			{
				p8ImageFrame->SetLeftVCenterImage(pImage);
			}				
		}
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_RIGHTVCENTER_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_RIGHTVCENTER_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			IImage* pImage = LoadImage(szValue);
			if (pImage)
			{
				p8ImageFrame->SetRightVCenterImage(pImage);
			}				
		}
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_LEFTBOTTOM_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_LEFTBOTTOM_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			IImage* pImage = LoadImage(szValue);
			if (pImage)
			{
				p8ImageFrame->SetLeftBottomImage(pImage);
			}				
		}
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_CENTERBOTTOM_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_CENTERBOTTOM_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			IImage* pImage = LoadImage(szValue);
			if (pImage)
			{
				p8ImageFrame->SetCenterBottomImage(pImage);
			}				
		}
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_RIGHTBOTTOM_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_RIGHTBOTTOM_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			IImage* pImage = LoadImage(szValue);
			if (pImage)
			{
				p8ImageFrame->SetRightBottomImage(pImage);
			}				
		}	
		//background.margin
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_BACKGROUND_MARGIN_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_BACKGROUND_MARGIN_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			RECT rcMargin = {0};
			CString strThickness = szValue;
			int nToken = 0;
			rcMargin.left = _ttoi(strThickness.Tokenize(SCRIPTLET_SEPARATOR, nToken));
			if (nToken > _tcslen(szValue))
			{
				rcMargin.top = rcMargin.left;
				rcMargin.right = rcMargin.left;
				rcMargin.bottom = rcMargin.top;
			}
			else
			{
				rcMargin.top = _ttoi(strThickness.Tokenize(SCRIPTLET_SEPARATOR, nToken));
				if (nToken > _tcslen(szValue))
				{
					rcMargin.right = rcMargin.left;
					rcMargin.bottom = rcMargin.top;
				}
				else
				{
					rcMargin.right =  _ttoi(strThickness.Tokenize(SCRIPTLET_SEPARATOR, nToken));
					if (nToken > _tcslen(szValue))
					{
						rcMargin.bottom = rcMargin.top;
					}
					else
					{
						rcMargin.bottom = _ttoi(strThickness.Tokenize(SCRIPTLET_SEPARATOR, nToken));
					}
				}
			}
			p8ImageFrame->SetBackgroundMargin(&rcMargin);
		}	

	}
	return bSuccess;
}